package com.ck.clients;

import com.ck.library.BoSlLibraryRemote;
import com.ck.domain.Book;
import com.ck.library.BrSlLibraryRemote;
import com.ck.domain.Borrower;
import com.ck.library.LoSlLibraryRemote;
import com.ck.domain.Loan;
import com.ck.library.QuantityRemote;
import com.ck.library.dueDateRemote;

import javax.naming.InitialContext;
import javax.naming.Context;
import javax.naming.NamingException;

import javax.rmi.PortableRemoteObject;

public class Client
{
    public static void main(String [] args)
    {
        try
	{
            Context jndiContext = getInitialContext();
            Object ref = jndiContext.lookup("BrSlLibraryRemote");
            BrSlLibraryRemote br = (BrSlLibraryRemote)
            PortableRemoteObject.narrow(ref,BrSlLibraryRemote.class);

            Borrower br1=new Borrower();
            br1.setCardNo(9980);
            br1.setFirstName("Mohammed");
            br1.setLastName("Khalid");
            br1.setPhone("07789654");
            br1.setPostalCode("EH11 1JK");
            br.createBrrower(br1);

            Borrower br2=new Borrower();
            br2.setCardNo(9680);
            br2.setFirstName("Sami");
            br2.setLastName("Nesta");
            br2.setPhone("07787694");
            br2.setPostalCode("EH10 1GK");
            br.createBrrower(br2);

            Borrower br3=new Borrower();
            br3.setCardNo(6680);
            br3.setFirstName("Alberto");
            br3.setLastName("George");
            br3.setPhone("07743694");
            br3.setPostalCode("EH12 1GK");
            br.createBrrower(br3);

           Borrower br_finder = br.findBorrower(6680);
            System.out.println(br_finder.getFirstName());
            System.out.println(br_finder.getLastName());
            System.out.println(br_finder.getPhone());
            System.out.println(br_finder.getPostalCode());

            Object re = jndiContext.lookup("BoSlLibraryRemote");
            BoSlLibraryRemote bk = (BoSlLibraryRemote)
            PortableRemoteObject.narrow(re,BoSlLibraryRemote.class);

            Book b1 = new Book();
            b1.setIsbn(9999);
            b1.setTitle("PEACE & WAR");
            b1.setAuthor("Louis");
            b1.setBorrower(br1);
            bk.createBook(b1);

            Book b2 = new Book();
            b2.setIsbn(9599);
            b2.setTitle("Natural World");
            b2.setAuthor("Alesandro Jo");
            b2.setBorrower(br2);
            bk.createBook(b2);

            Book b3 = new Book();
            b3.setIsbn(9588);
            b3.setTitle("Computer Network");
            b3.setAuthor("Alberto Jone");
            b3.setBorrower(br3);
            bk.createBook(b3);

            Book bk_finder =bk.findBook(9599);
            System.out.println(bk_finder.getTitle());
            System.out.println(bk_finder.getAuthor());
            System.out.println(bk_finder.getBorrower());

            Object rel = jndiContext.lookup("LoSlLibraryRemote");
            LoSlLibraryRemote lo = (LoSlLibraryRemote)
            PortableRemoteObject.narrow(rel,LoSlLibraryRemote.class);
            Loan l1=new Loan();
            l1.getBorrowers().add(br1);
            l1.getBorrowers().add(br2);
            l1.getBorrowers().add(br3);
            l1.getBooks().add(b1);
            l1.getBooks().add(b2);
            l1.getBooks().add(b3);
            lo.createLoan(l1);

            System.out.println(lo);



        }
        catch (javax.naming.NamingException ne)
        {
	    ne.printStackTrace();
	}
    }

    public static Context getInitialContext()
        throws javax.naming.NamingException
    {
        return new javax.naming.InitialContext();
    }
}
